#include "libmpib.h"
#include "mpib_p2p_benchmarks.h"

extern "C" void MPIB_p2p_container_free(MPIB_p2p_container* container) {
	delete container;
}

class MPIB_Send_Recv_container: public MPIB_p2p_container {
private:
	char* buffer;

public:
	MPIB_Send_Recv_container() {
		MPIB_p2p_container::operation = "MPI_Send-MPI_Recv";
		MPIB_p2p_container::initialize = initialize;
		MPIB_p2p_container::execute_measure = execute_measure;
		MPIB_p2p_container::execute_mirror = execute_mirror;
		MPIB_p2p_container::finalize = finalize;
	}

	static void initialize(void* _this, MPI_Comm comm, int M) {
		MPIB_Send_Recv_container* container = (MPIB_Send_Recv_container*)_this;
		container->buffer = (char*)malloc(sizeof(char) * M);
	}

	static void execute_measure(void* _this, MPI_Comm comm, int M, int mirror) {
		MPIB_Send_Recv_container* container = (MPIB_Send_Recv_container*)_this;
		MPI_Send(container->buffer, M, MPI_CHAR, mirror, 0, comm);
		MPI_Recv(container->buffer, M, MPI_CHAR, mirror, 0, comm, MPI_STATUS_IGNORE);
	}

	static void execute_mirror(void* _this, MPI_Comm comm, int M, int measure) {
		MPIB_Send_Recv_container* container = (MPIB_Send_Recv_container*)_this;
		MPI_Recv(container->buffer, M, MPI_CHAR, measure, 0, comm, MPI_STATUS_IGNORE);
		MPI_Send(container->buffer, M, MPI_CHAR, measure, 0, comm);
	}

	static void finalize(void* _this, MPI_Comm comm) {
		MPIB_Send_Recv_container* container = (MPIB_Send_Recv_container*)_this;
		free(container->buffer);
	}
};

extern "C" MPIB_p2p_container* MPIB_Send_Recv_container_alloc() {
	return new MPIB_Send_Recv_container;
}
