#ifndef MPIB_P2P_CONTAINERS_H_
#define MPIB_P2P_CONTAINERS_H_

#include "mpib_p2p_benchmarks.h"

/*!
 * \defgroup p2p_containers Containers for point-to-point communication operations
 * Data structures describing point-to-point communications to be measured,
 * which are used as an argument of the point-to-point benchmark function.
 * \{
 */ 
#ifdef __cplusplus
extern "C" {
#endif

/*! Frees point-to-point container */
void MPIB_p2p_container_free(MPIB_p2p_container* container);

/*! Allocates MPI_Send-MPI_Recv container */
MPIB_p2p_container* MPIB_Send_Recv_container_alloc();

#ifdef __cplusplus
}
#endif
/*!
 * \}
 */

#endif /*MPIB_P2P_CONTAINERS_H_*/
