#ifndef LIBMPIB_COLL_H_
#define LIBMPIB_COLL_H_

/*!
 * \file
 * Precompiled header
 */
#include "config.h"

#include <mpi.h>
#include <string.h>

/*! Verbose mode (stderr) */
extern int mpib_coll_verbose;

/*!
 * scatterv/gatherv mode:
 * - \i 0 propagated on duplicated communicator (default)
 * - \i 1 broadcasted counts
 * - \i 2 propagated with tags: not safe
 * - \i 3 everywhere-defined counts: not standard
 */
extern int mpib_coll_sgv;

/*! tag for scatterv/gatherv - not safe, incremental on all processors */
extern int mpib_coll_sgv_tag;

#endif /* LIBMPIB_COLL_H_ */
